//+------------------------------------------------------------------+
//|                                                .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black

double g_ibuf_76[];
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
int gi_100;
int gi_104;
extern int AllBars = 240;
extern int BarsForFract = 0;
int gi_116 = 0;
double gd_120 = 0.0;
int gi_128 = -1;
int gi_132 = -1;
int gi_136 = 0;
double g_price_140 = 0.0;
double g_price_148 = 0.0;
double g_price_156 = 0.0;
int gi_164 = 0;
int gi_168 = 300;
int gi_172 = 0;
int gi_176 = 0;
double gd_180 = 0.0;
int g_time_188;
int g_time_192;
double gd_196;
double gd_204;
datetime g_time_212;
extern int ChannelAlert = 50;
extern int SlopeAlert = 25;
extern bool ChannelTalk = TRUE;
int gi_228 = 0;

int init() {
   if (Year() >= 2008 && Month() >= 6) {
      Comment("   !!!");
      return (0);
   }
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 164);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexEmptyValue(0, 0.0);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexBuffer(2, g_ibuf_84);
   SetIndexBuffer(3, g_ibuf_88);
   SetIndexBuffer(4, g_ibuf_92);
   SetIndexBuffer(5, g_ibuf_96);
   return (0);
}

int deinit() {
   return (0);
}

void DelObj() {
   ObjectDelete("TL1");
   ObjectDelete("TL2");
   ObjectDelete("MIDL");
}

int start() {
   string ls_unused_12;
   string ls_unused_20;
   int li_unused_0 = IndicatorCounted();
   int li_unused_4 = Ask - g_price_140;
   int li_unused_8 = Bid - g_price_148;
   if (Symbol() == "EURUSD") ls_unused_12 = "Euro Dollar";
   if (Symbol() == "EURJPY") ls_unused_12 = "Euro Yen ";
   if (Symbol() == "EURAUD") ls_unused_12 = "Euro Aussie ";
   if (Symbol() == "EURCAD") ls_unused_12 = "Euro Canadian";
   if (Symbol() == "EURCHF") ls_unused_12 = "Euro Swiss";
   if (Symbol() == "GBPUSD") ls_unused_12 = "Cable Dollar";
   if (Symbol() == "GBPJPY") ls_unused_12 = "Cable Yen ";
   if (Symbol() == "GBPCHF") ls_unused_12 = "Cable Swiss";
   if (Symbol() == "AUDUSD") ls_unused_12 = "Aussie";
   if (Symbol() == "USDCHF") ls_unused_12 = "Swiss Dollar";
   if (Symbol() == "USDCAD") ls_unused_12 = "Canada";
   if (Symbol() == "USDJPY") ls_unused_12 = "Yen Dollar";
   if (Symbol() == "CHFJPY") ls_unused_12 = "Swiss Yen ";
   if (Symbol() == "GOLD") ls_unused_12 = "Gold";
   if (Period() == PERIOD_M1) ls_unused_20 = "One minute";
   if (Period() == PERIOD_M5) ls_unused_20 = "Five minutes";
   if (Period() == PERIOD_M15) ls_unused_20 = "Fifteen minutes";
   if (Period() == PERIOD_M30) ls_unused_20 = "Thirty minutes";
   if (Period() == PERIOD_H1) ls_unused_20 = "One hour";
   if (Period() == PERIOD_H4) ls_unused_20 = "Four hours";
   if (Period() == PERIOD_D1) ls_unused_20 = "Day";
   if (Period() == PERIOD_W1) ls_unused_20 = "Week";
   if (AllBars == 0 || Bars < AllBars) gi_168 = Bars;
   else gi_168 = AllBars;
   if (BarsForFract > 0) gi_172 = BarsForFract;
   else {
      switch (Period()) {
      case PERIOD_M1:
         gi_172 = 12;
         break;
      case PERIOD_M5:
         gi_172 = 48;
         break;
      case PERIOD_M15:
         gi_172 = 24;
         break;
      case PERIOD_M30:
         gi_172 = 24;
         break;
      case PERIOD_H1:
         gi_172 = 12;
         break;
      case PERIOD_H4:
         gi_172 = 15;
         break;
      case PERIOD_D1:
         gi_172 = 10;
         break;
      case PERIOD_W1:
         gi_172 = 6;
         break;
      default:
         DelObj();
         return (-1);
      }
   }
   gi_116 = 2;
   gi_128 = -1;
   gi_132 = -1;
   gi_136 = 0;
   while (gi_128 == -1 || gi_132 == -1 && gi_116 < gi_168) {
      if (gi_136 < 1 && gi_116 == iLowest(Symbol(), Period(), MODE_LOW, gi_172 << 1 + 1, gi_116 - gi_172)) {
         if (gi_136 == 0) {
            gi_136 = -1;
            gi_128 = gi_116;
            g_price_140 = Low[gi_128];
         } else {
            gi_132 = gi_116;
            g_price_148 = Low[gi_132];
         }
      }
      if (gi_136 > -1 && gi_116 == iHighest(Symbol(), Period(), MODE_HIGH, gi_172 << 1 + 1, gi_116 - gi_172)) {
         if (gi_136 == 0) {
            gi_136 = 1;
            gi_128 = gi_116;
            g_price_140 = High[gi_128];
         } else {
            gi_132 = gi_116;
            g_price_148 = High[gi_132];
         }
      }
      gi_116++;
   }
   if (gi_128 == -1 || gi_132 == -1) {
      DelObj();
      return (-1);
   }
   gd_120 = (g_price_148 - g_price_140) / (gi_132 - gi_128);
   g_price_140 -= gi_128 * gd_120;
   gi_128 = 0;
   gi_176 = 0;
   gd_180 = 0;
   if (gi_136 == 1) {
      g_price_156 = Low[2] - 2.0 * gd_120;
      for (gi_164 = 3; gi_164 <= gi_132; gi_164++)
         if (Low[gi_164] < g_price_156 + gd_120 * gi_164) g_price_156 = Low[gi_164] - gi_164 * gd_120;
      if (Low[0] < g_price_156) {
         gi_176 = 0;
         gd_180 = g_price_156;
      }
      if (Low[1] < g_price_156 + gd_120) {
         gi_176 = 1;
         gd_180 = g_price_156 + gd_120;
      }
      if (High[0] > g_price_140) {
         gi_176 = 0;
         gd_180 = g_price_140;
      }
      if (High[1] > g_price_140 + gd_120) {
         gi_176 = 1;
         gd_180 = g_price_140 + gd_120;
      }
   } else {
      g_price_156 = High[2] - 2.0 * gd_120;
      for (gi_164 = 3; gi_164 <= gi_132; gi_164++)
         if (High[gi_164] > g_price_156 + gd_120 * gi_164) g_price_156 = High[gi_164] - gi_164 * gd_120;
      if (Low[0] < g_price_140) {
         gi_176 = 0;
         gd_180 = g_price_140;
      }
      if (Low[1] < g_price_140 + gd_120) {
         gi_176 = 1;
         gd_180 = g_price_140 + gd_120;
      }
      if (High[0] > g_price_156) {
         gi_176 = 0;
         gd_180 = g_price_156;
      }
      if (High[1] > g_price_156 + gd_120) {
         gi_176 = 1;
         gd_180 = g_price_156 + gd_120;
      }
   }
   g_price_148 = g_price_140 + gi_168 * gd_120;
   g_time_188 = Time[gi_128];
   g_time_192 = Time[gi_168];
   if (gd_180 != 0.0) g_ibuf_76[gi_176] = gd_180;
   DelObj();
   double ld_40 = MathAbs(g_price_156 - g_price_140) / Point;
   double ld_48 = MathFloor(100.0 * ((-gd_120) / Point));
   if (Period() == PERIOD_M1) {
      ObjectDelete("M1-TL1");
      ObjectCreate("M1-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("M1-TL1", OBJPROP_COLOR, Navy);
      else ObjectSet("M1-TL1", OBJPROP_COLOR, Red);
      ObjectSet("M1-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("M1-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M1-TL2");
      ObjectCreate("M1-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("M1-TL2", OBJPROP_COLOR, Navy);
      else ObjectSet("M1-TL2", OBJPROP_COLOR, Red);
      ObjectSet("M1-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("M1-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M1-MIDL");
      ObjectCreate("M1-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("M1-MIDL", OBJPROP_COLOR, Navy);
      else ObjectSet("M1-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("M1-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("M1-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_M5) {
      ObjectDelete("M5-TL1");
      ObjectCreate("M5-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("M5-TL1", OBJPROP_COLOR, SeaGreen);
      else ObjectSet("M5-TL1", OBJPROP_COLOR, Red);
      ObjectSet("M5-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("M5-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M5-TL2");
      ObjectCreate("M5-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("M5-TL2", OBJPROP_COLOR, SeaGreen);
      else ObjectSet("M5-TL2", OBJPROP_COLOR, Red);
      ObjectSet("M5-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("M5-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M5-MIDL");
      ObjectCreate("M5-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("M5-MIDL", OBJPROP_COLOR, SeaGreen);
      else ObjectSet("M5-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("M5-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("M5-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_M15) {
      ObjectDelete("M15-TL1");
      ObjectCreate("M15-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("M15-TL1", OBJPROP_COLOR, DarkOrange);
      else ObjectSet("M15-TL1", OBJPROP_COLOR, Red);
      ObjectSet("M15-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("M15-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M15-TL2");
      ObjectCreate("M15-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("M15-TL2", OBJPROP_COLOR, DarkOrange);
      else ObjectSet("M15-TL2", OBJPROP_COLOR, Red);
      ObjectSet("M15-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("M15-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M15-MIDL");
      ObjectCreate("M15-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("M15-MIDL", OBJPROP_COLOR, DarkOrange);
      else ObjectSet("M15-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("M15-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("M15-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_M30) {
      ObjectDelete("M30-TL1");
      ObjectCreate("M30-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("M30-TL1", OBJPROP_COLOR, Bisque);
      else ObjectSet("M30-TL1", OBJPROP_COLOR, Red);
      ObjectSet("M30-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("M30-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M30-TL2");
      ObjectCreate("M30-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("M30-TL2", OBJPROP_COLOR, Bisque);
      else ObjectSet("M30-TL2", OBJPROP_COLOR, Red);
      ObjectSet("M30-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("M30-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("M30-MIDL");
      ObjectCreate("M30-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("M30-MIDL", OBJPROP_COLOR, Bisque);
      else ObjectSet("M30-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("M30-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("M30-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_H1) {
      ObjectDelete("H1-TL1");
      ObjectCreate("H1-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("H1-TL1", OBJPROP_COLOR, Yellow);
      else ObjectSet("H1-TL1", OBJPROP_COLOR, Red);
      ObjectSet("H1-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("H1-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("H1-TL2");
      ObjectCreate("H1-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("H1-TL2", OBJPROP_COLOR, Yellow);
      else ObjectSet("H1-TL2", OBJPROP_COLOR, Red);
      ObjectSet("H1-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("H1-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("H1-MIDL");
      ObjectCreate("H1-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("H1-MIDL", OBJPROP_COLOR, Yellow);
      else ObjectSet("H1-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("H1-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("H1-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_H4) {
      ObjectDelete("H4-TL1");
      ObjectCreate("H4-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("H4-TL1", OBJPROP_COLOR, LightSkyBlue);
      else ObjectSet("H4-TL1", OBJPROP_COLOR, Red);
      ObjectSet("H4-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("H4-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("H4-TL2");
      ObjectCreate("H4-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("H4-TL2", OBJPROP_COLOR, LightSkyBlue);
      else ObjectSet("H4-TL2", OBJPROP_COLOR, Red);
      ObjectSet("H4-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("H4-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("H4-MIDL");
      ObjectCreate("H4-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("H4-MIDL", OBJPROP_COLOR, LightSkyBlue);
      else ObjectSet("H4-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("H4-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("H4-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_D1) {
      ObjectDelete("D1-TL1");
      ObjectCreate("D1-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("D1-TL1", OBJPROP_COLOR, Ivory);
      else ObjectSet("D1-TL1", OBJPROP_COLOR, Red);
      ObjectSet("D1-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("D1-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("D1-TL2");
      ObjectCreate("D1-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("D1-TL2", OBJPROP_COLOR, Ivory);
      else ObjectSet("D1-TL2", OBJPROP_COLOR, Red);
      ObjectSet("D1-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("D1-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("D1-MIDL");
      ObjectCreate("D1-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("D1-MIDL", OBJPROP_COLOR, Ivory);
      else ObjectSet("D1-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("D1-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("D1-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   if (Period() == PERIOD_W1) {
      ObjectDelete("W1-TL1");
      ObjectCreate("W1-TL1", OBJ_CHANNEL, 0, g_time_192, g_price_156 + gd_120 * gi_168, g_time_188, g_price_156);
      if (ld_40 >= ChannelAlert) ObjectSet("W1-TL1", OBJPROP_COLOR, Lime);
      else ObjectSet("W1-TL1", OBJPROP_COLOR, Red);
      ObjectSet("W1-TL1", OBJPROP_WIDTH, 2);
      ObjectSet("W1-TL1", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("W1-TL2");
      ObjectCreate("W1-TL2", OBJ_CHANNEL, 0, g_time_192, g_price_148, g_time_188, g_price_140);
      if (ld_40 >= ChannelAlert) ObjectSet("W1-TL2", OBJPROP_COLOR, Lime);
      else ObjectSet("W1-TL2", OBJPROP_COLOR, Red);
      ObjectSet("W1-TL2", OBJPROP_WIDTH, 2);
      ObjectSet("W1-TL2", OBJPROP_STYLE, STYLE_SOLID);
      ObjectDelete("W1-MIDL");
      ObjectCreate("W1-MIDL", OBJ_CHANNEL, 0, g_time_192, (g_price_148 + g_price_156 + gd_120 * gi_168) / 2.0, g_time_188, (g_price_140 + g_price_156) / 2.0);
      if (ld_40 >= ChannelAlert && MathAbs(ld_48) >= SlopeAlert) ObjectSet("W1-MIDL", OBJPROP_COLOR, Lime);
      else ObjectSet("W1-MIDL", OBJPROP_COLOR, Red);
      ObjectSet("W1-MIDL", OBJPROP_WIDTH, 1);
      ObjectSet("W1-MIDL", OBJPROP_STYLE, STYLE_DOT);
   }
   GlobalVariableSet("ST1", g_time_192);
   GlobalVariableSet("ST2", g_time_188);
   GlobalVariableSet("Bar1", gi_100);
   GlobalVariableSet("Bar2", gi_104);
   ObjectCreate("Dot1", OBJ_ARROW, 0, g_time_188, (g_price_140 + g_price_156) / 2.0);
   ObjectSet("Dot1", 252, 55295);
   string ls_unused_28 = "Change";
   if (gd_196 < ld_40) ls_unused_28 = "is widening";
   if (gd_196 > ld_40) ls_unused_28 = "is narrowing";
   if (gd_204 < 0.0 && ld_48 > 0.0) ls_unused_28 = "Changed direction to up";
   if (gd_204 > 0.0 && ld_48 < 0.0) ls_unused_28 = "Changed direction to down";
   if (gi_228 && ChannelTalk && g_time_212 != Time[0] && gd_196 != ld_40 || gd_204 != ld_48) g_time_212 = Time[0];
   gd_196 = ld_40;
   gd_204 = ld_48;
   gi_228++;
   g_ibuf_80[gi_128] = g_price_140;
   g_ibuf_84[gi_128] = g_price_156;
   g_ibuf_88[gi_128] = (g_price_140 + g_price_156) / 2.0;
   g_ibuf_92[gi_128] = ld_40;
   g_ibuf_96[gi_128] = ld_48;
   return (0);
}